/***
 * 
 * txt2ps - Takes as parameter and returns it in nice 
 *	    formatted postscript with a header and footer.
 *
 * Modified from my "psmail" prog from May-93
 *
 *   harry@swin.edu.au Sep-95
 *
 ***/
  
#include <stdio.h>
#include <time.h>
#include <string.h>

/* This Postscript prologue is stolen from mp.pro.ps */

char prolog[]= {
"%!PS-Adobe-1.0\n\
%%Creator: Steve Holden\n\
%%Modified: John Macdonald\n\
%%Title: @(#)mp.pro.ps 2.15 91/09/14\n\
%%CreationDate: see above\n\
%%PageLength 60\n\
%%LineLength 80\n\
%%DocumentFonts: Times-Bold Times-Roman Courier\n\
%%Pages: (atend)\n\
%%EndComments\n\
\n\
/inch { 72 mul } bind def\n\
%\n\
%  IMPORTANT NOTE: The following two variables should be set correctly.\n\
%                  Reasonable values for fullwidth and fullheight are\n\
%                  8.5/11 inch for US Letter, and 8.5/11.4 inch for A4.\n\
%                  Since sites usually have one single format of paper,\n\
%                  mp should be installed with either the USLetter or A4\n\
%                  values.\n\
%\n\
/fullwidth 8.5 inch def\n\
/fullheight 11 inch def\n\
\n\
%Title: backspacefont.ps suggested by Glenn Reid (Adobe Systems).\n\
\n\
/backspacefont {\n\
    /Courier findfont dup length dict begin\n\
        { %forall\n\
            1 index /FID eq { pop pop } { def } ifelse\n\
        } forall\n\
        currentdict /UniqueID known { %if\n\
              /UniqueID UniqueID 16#800000 xor def\n\
        } if\n\
        CharStrings length 1 add dict begin\n\
            CharStrings { def } forall\n\
          /backspace { -600 0 setcharwidth } bind def\n\
            currentdict\n\
      end\n\
        /CharStrings exch def\n\
        /Encoding Encoding 256 array copy def\n\
        Encoding 8 /backspace put\n\
        currentdict\n\
    end\n\
    definefont\n\
} bind def\n\
\n\
/setmargin {\n\
  /leftedge 0 def\n\
  /bottomedge 0 def\n\
  fullheight fullwidth LandscapeMode { exch } if\n\
    /rightedge exch def\n\
    /topedge exch def\n\
  9 7 LandscapeMode { exch } if pop\n\
    /FontSize exch def\n\
\n\
  /CourierBack backspacefont\n\
  \n\
  /font1d /Times-Bold            findfont def\n\
  /font2d /Times-Roman           findfont def\n\
  /font3d /CourierBack           findfont def\n\
  /fontHd /Helvetica-BoldOblique findfont 14 scalefont def\n\
  /fontH2 /Helvetica-BoldOblique findfont 10 scalefont def\n\
  /fontNd /Times-Bold            findfont 12 scalefont def\n\
  \n\
  /BoldFont      { font1d FontSize scalefont setfont } bind def\n\
  /pf            { font2d FontSize scalefont setfont } bind def\n\
  /sf            { font3d FontSize scalefont setfont } bind def\n\
  /fontH         { fontHd setfont } bind def\n\
  /fontD         { fontH2 setfont } bind def\n\
  /fontN         { fontNd setfont } bind def\n\
} def\n\
\n\
/graybox% grey x1 y1 x2 y2 graybox --\n\
{\n\
    newpath\n\
      4 -1 roll 2 copy% y2 x1\n\
      10 sub exch moveto\n\
      4 -1 roll 2 copy% x1 y1\n\
      10 180 270 arc\n\
      4 -1 roll 1 copy 3 -1 roll% x2 y1\n\
      10 270 0 arc\n\
      3 -1 roll 1 copy 3 1 roll% x1 y2 x2 y2\n\
      10 0 90 arc\n\
      10 90 180 arc\n\
    closepath\n\
    gsave\n\
      setgray fill\n\
    grestore\n\
    0 setgray stroke\n\
} def\n\
\n\
/endpage% page_number endpage --\n\
{\n\
  gsave\n\
    % listing type, user, date across the bottom\n\
    0.88                                % gray level\n\
    leftedge  50 add topedge 56 sub     % bottom lt corner\n\
    rightedge 95 sub topedge 36 sub     % top rt corner\n\
    graybox\n\
    leftedge 50 add topedge 50 sub moveto\n\
    fontD\n\
    MailFor show\n\
    fontH\n\
    User show\n\
    fontD\n\
    rightedge 95 sub TimeNow stringwidth pop sub\n\
    topedge 52 sub moveto TimeNow show\n\
    % page number to the bottom right corner\n\
    1                                   % gray level\n\
    rightedge 70 sub topedge 56 sub     % bottom lt\n\
    rightedge 50 sub topedge 36 sub     % top rt\n\
    graybox\n\
    fontD\n\
    (Page) dup stringwidth\n\
       topedge 40 sub exch sub                  % y-centered\n\
       exch 2 div rightedge 60 sub exch sub     % x-centered\n\
       exch moveto show\n\
    fontH\n\
    dup stringwidth\n\
       topedge 58 sub exch sub                  % y-centered\n\
       exch 2 div rightedge 60 sub exch sub     % x-centered\n\
       exch moveto show\n\
    0.88                                   % gray level\n\
    leftedge  50 add bottomedge 50 add     % bottom lt corner\n\
    rightedge 50 sub bottomedge 70 add     % top rt corner\n\
    graybox\n\
    fontH\n\
    % compute x pos for centring\n\
      % ((l+50) + (r-50)) / 2 is the page centre\n\
      leftedge rightedge add 2 div\n\
      % but we want to start at the beginning of the string, not the middle\n\
      Subject stringwidth pop 2 div sub\n\
    % y pos is simple\n\
      bottomedge 54 add\n\
      moveto\n\
    Subject show\n\
  grestore\n\
  PageSave restore      % restore *always* before showpage\n\
  showpage% display it\n\
} def\n\
\n\
/endcol% page_number col_number endcol --\n\
{\n\
  pop% get rid of col_number\n\
  pop                   % get rid of page_number\n\
  /ypos topedge 92 sub def\n\
  /xpos rightedge leftedge sub 2 div def\n\
  xpos ypos moveto\n\
} def\n\
\n\
/newpage% page_number newpage --\n\
{\n\
  pop% pageno\n\
  /PageSave save def\n\
  LandscapeMode {setlandscape} if\n\
  /lct 0 def\n\
  /ypos topedge 92 sub def\n\
  /xpos leftedge 50 add def\n\
  xpos ypos moveto\n\
  sf\n\
} def\n\
\n\
/setlandscape\n\
{\n\
  612 0 translate\n\
  90 rotate\n\
} def\n\
\n\
/showline\n\
{\n\
  show\n\
  /ypos ypos FontSize sub def\n\
  xpos ypos moveto\n\
} def\n\
\n\
106 45 {dup mul exch dup mul add 1.0 exch sub} setscreen\n\
\n\
/LandscapeMode false def\n\
\n\
setmargin\n"
};

char pstext1[] = {
"%%EndProlog\n\
%%Page: ? 1\n\
(1) newpage\n\
/MailFor (Mail for ) def\n"};

/* It starts here. */
/***
 * txt2ps - Returns a pointer to a Postscript 
 *	    buf - txt file to turn into PostScript.
 *	    header - Line to print on the top banner.
 *	    footer - Line to print on the trailer.
 ***/

char *txt2ps(buf, header, footer)
char *buf, *header, *footer;
{

    char line[256], header[256],timenow[64],fromline1[256],subjecttail[256],
	 *pbuf, thetime[32], *p, fromline2[256],subject[256],toline[256];
    time_t now;
    int i,gothead=0,printed_head=0, page=1, n=6;

/* alloc enough for everthing ( including date string ) */

    pbuf = calloc((strlen(prolog)+strlen(buf)+
		  strlen(header)+strlen(trialer)+100), sizeof(char));

    sprintf(subjecttail,"/Subject ( %s) def\n",trailer);

    while ( fgets(line,256,stdin) != NULL) {
	i = strlen(line);
	if ( isspace(line[i-1])) line[i-1] = '\0';
	while (p = strchr(line,'(')) *p='[';
	while (p = strchr(line,')')) *p=']';

/* Pick out the bits in the header, and format them into PS lines */

/*
	if (!gothead) {
	    if (strncmp(line,"From:",5) == 0) 
	       sprintf(fromline2,"BoldFont (%s) showline\n",line);
	    else if (strncmp(line,"From",4) ==0) 
	       sprintf(fromline1,"BoldFont (%s) showline\n",line);
	    else if (strncmp(line, "To:", 3) == 0) { 
		sprintf(toline,"BoldFont (%s) showline\n",line);
	        if (strlen(line) > 40)	/* overwites header if > */
		    line[42] = '\0';
		if ( (p = strchr(line,'=')) != NULL)
		   *p=' ';
		if ( (p = strchr(line,'@')) != NULL)
		   *p='\0';
	        sprintf(header,"/User (%s) def\n",line+4);
	    } else if (strncmp(line, "Subject:",8) ==0) {
		sprintf(subject,"BoldFont (%s) showline\n",line);
	    } else if (i == 1)
	        gothead = 1;

/* Got the header , now print it */ 

	 } else {	
	    if (!printed_head) {

/* harry */
		
		(void) time(&now);
		strcpy(thetime, ctime(&now));
		i = strlen(thetime);
		thetime[i-1] = '\0'; 

		sprintf(pbuf,"%s\n/TimeNow ( %s ) def\n\
%s\n", prolog, ,pstext1,thetime);

		fprintf(stdout,"%s",prolog);
    		sprintf(timenow,"/TimeNow ( %s ) def\n",thetime); 

    		fprintf(stdout,"%s",pstext1);
	  	fprintf(stdout,"%s",header);
		fprintf(stdout,"%s",timenow);
		fprintf(stdout,"%s",subjecttail);
		fprintf(stdout,"%s",toline);
		fprintf(stdout,"%s",fromline1);
		fprintf(stdout,"%s",fromline2);
		fprintf(stdout,"%s",subject);
		fprintf(stdout,"sf () showline\n");
	        printed_head = 1;
	    } 

/* print a line from the body of message */

	    fprintf(stdout,"sf (%s) showline\n",line);
	    n++;
	    if ((n % 66) == 1) {		/* new page */
		fprintf(stdout,"(%d) %d endcol\n",page);
		fprintf(stdout,"(%d) endpage\n",page);
		page++;
		fprintf(stdout,"%%%%Page ? %d\n",page);
		fprintf(stdout,"(%d) newpage\n",page);
		fprintf(stdout,"/MailFor (Mail for ) def\n");
	  	fprintf(stdout,"%s",header);
		fprintf(stdout,"%s",timenow);
		fprintf(stdout,"%s",subjecttail);
	    }
	 }
	} /* while */

/* Output postscript trailer */

	if (gothead) {
	   if (( n % 66) !=1)
	      fprintf(stdout,"(%d) endpage\n",page);
	   fprintf(stdout,"%%%%Trailer\n");
	   fprintf(stdout,"%%%%Pages: %d\n",page);
	}
	return(pbuf);
}	
